use ExtUtils::MakeMaker;

WriteMakefile(
    NAME        => 'BeastBB',
    VERSION     => '0.1',
    INST_SCRIPT => './bin',
    INST_BIN    => './bin',
    test        => { TESTS => 't/*.t' },
);

package MY {

    sub top_targets {
        my $self   = shift;
        my $return = $self->SUPER::top_targets(@_);
        $return = [ split /\n/, $return ];
        for my $i ( keys @$return ) {
            $return->[$i] .= ' install_frontend'
              if $return->[$i] =~ /^all :/;
        }
        return join "\n", @$return;
    }

    sub postamble {
        return
            "\n"
          . "install_frontend:\n"
          . "\tif [ ! -e lib/BeastBB/public  ]; then "
          . "mkdir -pv lib/BeastBB/public; " . "fi;"
          . "if [ ! -e lib/BeastBB/templates  ]; then "
          . "mkdir -pv lib/BeastBB/templates; " . "fi; "
          . "cp -rfv templates/* lib/BeastBB/templates/; "
          . "cp -rfv public/* lib/BeastBB/public/; ";
    }
}
